Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 667)
@@ -1243,7 +1090,84 @@
           w_m_n(:,:,:) = w(:,ny-1:ny,:)
        ENDIF
-
-    ENDIF
-
+       
+    ENDIF
+!
+!-- Calculate the initial volume flow at the right and north boundary
+    IF ( conserve_volume_flow ) THEN
+
+       volume_flow_initial_l = 0.0
+       volume_flow_area_l    = 0.0
+  
+       IF  ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
+
+          IF ( nxr == nx )  THEN
+             DO  j = nys, nyn
+                DO  k = nzb_2d(j,nx) + 1, nzt
+                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
+                                              hom_sum(k,1,0) * dzw(k)
+                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
+                ENDDO
+             ENDDO
+          ENDIF
+          
+          IF ( nyn == ny )  THEN
+             DO  i = nxl, nxr
+                DO  k = nzb_2d(ny,i) + 1, nzt  
+                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
+                                               hom_sum(k,2,0) * dzw(k)
+                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
+                ENDDO
+             ENDDO
+          ENDIF
+
+       ELSEIF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+
+          IF ( nxr == nx )  THEN
+             DO  j = nys, nyn
+                DO  k = nzb_2d(j,nx) + 1, nzt
+                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
+                                               u(k,j,nx) * dzw(k)
+                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
+                ENDDO
+             ENDDO
+          ENDIF
+          
+          IF ( nyn == ny )  THEN
+             DO  i = nxl, nxr
+                DO  k = nzb_2d(ny,i) + 1, nzt  
+                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
+                                              v(k,ny,i) * dzw(k)
+                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
+                ENDDO
+             ENDDO
+          ENDIF
+
+       ENDIF
+
+#if defined( __parallel )
+          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1),&
+                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
+          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1),      &
+                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
+
+          CALL MPI_ALLREDUCE( volume_flow_initial_l(2), volume_flow_initial(2),&
+                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
+          CALL MPI_ALLREDUCE( volume_flow_area_l(2), volume_flow_area(2),      &
+                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
+
+#else
+          volume_flow_initial = volume_flow_initial_l
+          volume_flow_area    = volume_flow_area_l
+#endif  
+
+!
+!--       In case of 'bulk_velocity' mode, volume_flow_initial is overridden
+!--       and calculated from u|v_bulk instead.
+          IF ( TRIM( conserve_volume_flow_mode ) == 'bulk_velocity' )  THEN
+             volume_flow_initial(1) = u_bulk * volume_flow_area(1)
+             volume_flow_initial(2) = v_bulk * volume_flow_area(2)
+          ENDIF
+
+       ENDIF
 !
 !-- Initialization of the leaf area density
@@ -1254,6 +1178,6 @@
           CASE( 'block' )
 
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    lad_s(:,j,i) = lad(:)
                    cdc(:,j,i)   = drag_coefficient
@@ -1277,10 +1201,10 @@
           END SELECT
 
-       CALL exchange_horiz( lad_s )
-       CALL exchange_horiz( cdc )
+       CALL exchange_horiz( lad_s, nbgp )
+       CALL exchange_horiz( cdc, nbgp )
 
        IF ( passive_scalar ) THEN
-          CALL exchange_horiz( sls )
-          CALL exchange_horiz( sec )
+          CALL exchange_horiz( sls, nbgp )
+          CALL exchange_horiz( sec, nbgp )
        ENDIF
 
@@ -1311,7 +1235,7 @@
        lad_w(nzt+1,:,:)     = lad_w(nzt,:,:)
 
-       CALL exchange_horiz( lad_u )
-       CALL exchange_horiz( lad_v )
-       CALL exchange_horiz( lad_w )
+       CALL exchange_horiz( lad_u, nbgp )
+       CALL exchange_horiz( lad_v, nbgp )
+       CALL exchange_horiz( lad_w, nbgp )
 
 !
@@ -1322,6 +1246,6 @@
 !--       integration of the leaf area density
           lai(:,:,:) = 0.0
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 DO  k = pch_index-1, 0, -1
                    lai(k,j,i) = lai(k+1,j,i) +                   &
@@ -1339,6 +1263,6 @@
 !--       Evaluation of the upward kinematic vertical heat flux within the 
 !--       canopy
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 DO  k = 0, pch_index
                    canopy_heat_flux(k,j,i) = cthf *                    &
@@ -1384,4 +1308,6 @@
 !-- Initialize quantities for special advections schemes
     CALL init_advec
+    IF ( momentum_advec == 'ws-scheme' .OR.  &
+         scalar_advec == 'ws-scheme' ) CALL ws_init
 
 !
@@ -1439,5 +1365,5 @@
     IF ( bc_lr == 'dirichlet/radiation' )  THEN
 
-       DO  i = nxl-1, nxr+1
+       DO  i = nxlg, nxrg
           IF ( i >= nx - outflow_damping_width )  THEN
              km_damp_x(i) = km_damp_max * MIN( 1.0,                    &
@@ -1452,5 +1378,5 @@
     ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
 
-       DO  i = nxl-1, nxr+1
+       DO  i = nxlg, nxrg
           IF ( i <= outflow_damping_width )  THEN
              km_damp_x(i) = km_damp_max * MIN( 1.0,                    &
@@ -1467,5 +1393,5 @@
     IF ( bc_ns == 'dirichlet/radiation' )  THEN
 
-       DO  j = nys-1, nyn+1
+       DO  j = nysg, nyng
           IF ( j >= ny - outflow_damping_width )  THEN
              km_damp_y(j) = km_damp_max * MIN( 1.0,                    &
@@ -1480,5 +1406,5 @@
     ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
 
-       DO  j = nys-1, nyn+1
+       DO  j = nysg, nyng
           IF ( j <= outflow_damping_width )  THEN
              km_damp_y(j) = km_damp_max * MIN( 1.0,                    &
@@ -1594,8 +1520,8 @@
 !-- buoyancy, etc. A zero value will occur for cases where all grid points of
 !-- the respective subdomain lie below the surface topography
-    ngp_2dh_outer   = MAX( 1, ngp_2dh_outer(:,:)   )
+    ngp_2dh_outer   = MAX( 1, ngp_2dh_outer(:,:)   ) 
     ngp_3d_inner    = MAX( INT(1, KIND = SELECTED_INT_KIND( 18 )),            &
                            ngp_3d_inner(:) )
-    ngp_2dh_s_inner = MAX( 1, ngp_2dh_s_inner(:,:) )
+    ngp_2dh_s_inner = MAX( 1, ngp_2dh_s_inner(:,:) ) 
 
     DEALLOCATE( ngp_2dh_l, ngp_2dh_outer_l, ngp_3d_inner_l, ngp_3d_inner_tmp )
Index: /palm/trunk/SOURCE/init_advec.f90
===================================================================
--- /palm/trunk/SOURCE/init_advec.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_advec.f90	(revision 667)
@@ -8,5 +8,5 @@
 ! Former revisions:
 ! -----------------
-! $Id$
+! $Id: init_advec.f90 484 2010-02-05 07:36:54Z raasch 
 ! RCS Log replace by Id keyword, revision history cleaned up
 !
Index: /palm/trunk/SOURCE/init_coupling.f90
===================================================================
--- /palm/trunk/SOURCE/init_coupling.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_coupling.f90	(revision 667)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! -----------------
-! 
+!
+! determination of target_id's moved to init_pegrid
+!
 !
 ! Former revisions:
@@ -24,4 +26,5 @@
     USE pegrid
     USE control_parameters
+    USE indices
 
     IMPLICIT NONE
@@ -48,4 +51,6 @@
 !-- ATTENTION: numprocs will be reset according to the new communicators
 #if defined ( __parallel )
+
+!myid_absolut = myid
     IF ( myid == 0 )  THEN
        READ (*,*,ERR=10,END=10)  coupling_mode, bc_data(1), bc_data(2)
@@ -94,19 +99,13 @@
 
        IF ( myid < bc_data(1) ) THEN
-          inter_color = 0
-          numprocs = bc_data(1)
+          inter_color     = 0
+          numprocs        = bc_data(1)
+          coupling_mode   = 'atmosphere_to_ocean'
        ELSE
-          inter_color = 1
-          numprocs = bc_data(2)
+          inter_color     = 1
+          numprocs        = bc_data(2)
+          coupling_mode   = 'ocean_to_atmosphere'
        ENDIF
-!
-!--    Calculate the target PE for coupling and set up the new communicators.
-!--    Currently only 1:1 topologies are supported.
-       target_id = myid - ISIGN( numprocs, inter_color - 1 )
-       IF ( inter_color == 0 ) THEN
-          coupling_mode = 'atmosphere_to_ocean'
-       ELSE
-          coupling_mode = 'ocean_to_atmosphere'
-       ENDIF
+
        CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, inter_color, 0, comm_palm, ierr )
        comm2d = comm_palm
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 667)
@@ -4,5 +4,10 @@
 ! Current revisions:
 ! -----------------
-! 
+! Definition of new array bounds nxlg, nxrg, nysg, nyng on each PE. 
+! Furthermore the allocation of arrays and steering of loops is done with these
+! parameters. Call of exchange_horiz are modified.
+! In case of dirichlet bounday condition at the bottom zu(0)=0.0
+! dzu_mg has to be set explicitly for a equally spaced grid near bottom.
+! ddzu_pres added to use a equally spaced grid near bottom.
 !
 ! Former revisions:
@@ -76,9 +81,15 @@
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE ::  distance
-
+    
+!
+!   Computation of the array bounds.
+    nxlg = nxl - nbgp
+    nxrg = nxr + nbgp
+    nysg = nys - nbgp
+    nyng = nyn + nbgp
 !
 !-- Allocate grid arrays
     ALLOCATE( ddzu(1:nzt+1), ddzw(1:nzt+1), dd2zu(1:nzt), dzu(1:nzt+1), &
-              dzw(1:nzt+1), l_grid(1:nzt), zu(0:nzt+1), zw(0:nzt+1) )
+              dzw(1:nzt+1), l_grid(1:nzt), zu(nzb:nzt+1), zw(nzb:nzt+1) )
 
 !
@@ -97,9 +108,13 @@
 !
 !--    Grid for atmosphere with surface at z=0 (k=0, w-grid).
-!--    Since the w-level lies on the surface, the first u-level (staggered!)
-!--    lies below the surface (used for "mirror" boundary condition).
 !--    The first u-level above the surface corresponds to the top of the 
 !--    Prandtl-layer.
-       zu(0) = - dz * 0.5
+
+       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2 ) THEN
+          zu(0) = 0.0
+      !    zu(0) = - dz * 0.5
+       ELSE
+          zu(0) = - dz * 0.5
+       ENDIF
        zu(1) =   dz * 0.5
 
@@ -173,4 +188,16 @@
        dd2zu(k) = 1.0 / ( dzu(k) + dzu(k+1) )
     ENDDO
+    
+!    
+!-- In case of FFT method or SOR swap inverse grid lenght ddzu to ddzu_fft and 
+!-- modify the lowest entry. This is necessary for atmosphere runs, because
+!-- zu(0) and so ddzu(1) changed. Accompanied with this modified arrays 
+!-- pressure solver uses wrong values and this causes kinks in the profiles
+!-- of turbulent quantities.  
+    IF ( psolver /= 'multigrid' ) THEN
+       ALLOCATE( ddzu_pres(1:nzt+1) )
+       ddzu_pres = ddzu
+       IF( .NOT. ocean ) ddzu_pres(1) = ddzu_pres(2)
+    ENDIF   
 
 !
@@ -187,4 +214,9 @@
 
        dzu_mg(:,maximum_grid_level) = dzu
+!       
+!--    To ensure a equally spaced grid. For ocean runs this is not necessary, 
+!--    because zu(0) does not changed so far. Also this would cause errors 
+!--    if a vertical stretching for ocean runs is used.
+       IF ( .NOT. ocean ) dzu_mg(1,maximum_grid_level) = dzu(2)
        dzw_mg(:,maximum_grid_level) = dzw
        nzt_l = nzt
@@ -239,34 +271,38 @@
 !-- the flag arrays needed for the multigrid method
     gls = 2**( maximum_grid_level )
+
     ALLOCATE( corner_nl(nys:nyn,nxl:nxr), corner_nr(nys:nyn,nxl:nxr),       &
               corner_sl(nys:nyn,nxl:nxr), corner_sr(nys:nyn,nxl:nxr),       &
-              nzb_local(-gls:ny+gls,-gls:nx+gls), nzb_tmp(-1:ny+1,-1:nx+1), &
+              nzb_local(-gls:ny+gls,-gls:nx+gls),                                   &
+              nzb_tmp(-nbgp:ny+nbgp,-nbgp:nx+nbgp),                         &
               wall_l(nys:nyn,nxl:nxr), wall_n(nys:nyn,nxl:nxr),             &
               wall_r(nys:nyn,nxl:nxr), wall_s(nys:nyn,nxl:nxr) )
-    ALLOCATE( fwxm(nys-1:nyn+1,nxl-1:nxr+1), fwxp(nys-1:nyn+1,nxl-1:nxr+1), &
-              fwym(nys-1:nyn+1,nxl-1:nxr+1), fwyp(nys-1:nyn+1,nxl-1:nxr+1), &
-              fxm(nys-1:nyn+1,nxl-1:nxr+1), fxp(nys-1:nyn+1,nxl-1:nxr+1),   &
-              fym(nys-1:nyn+1,nxl-1:nxr+1), fyp(nys-1:nyn+1,nxl-1:nxr+1),   &
-              nzb_s_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_s_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_u_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_u_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_v_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_v_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_w_inner(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_w_outer(nys-1:nyn+1,nxl-1:nxr+1),                         &
-              nzb_diff_s_inner(nys-1:nyn+1,nxl-1:nxr+1),                    &
-              nzb_diff_s_outer(nys-1:nyn+1,nxl-1:nxr+1),                    &
-              nzb_diff_u(nys-1:nyn+1,nxl-1:nxr+1),                          &
-              nzb_diff_v(nys-1:nyn+1,nxl-1:nxr+1),                          &
-              nzb_2d(nys-1:nyn+1,nxl-1:nxr+1),                              &
-              wall_e_x(nys-1:nyn+1,nxl-1:nxr+1),                            &
-              wall_e_y(nys-1:nyn+1,nxl-1:nxr+1),                            &
-              wall_u(nys-1:nyn+1,nxl-1:nxr+1),                              &
-              wall_v(nys-1:nyn+1,nxl-1:nxr+1),                              &
-              wall_w_x(nys-1:nyn+1,nxl-1:nxr+1),                            &
-              wall_w_y(nys-1:nyn+1,nxl-1:nxr+1) )
-
-    ALLOCATE( l_wall(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    ALLOCATE( fwxm(nysg:nyng,nxlg:nxrg), fwxp(nysg:nyng,nxlg:nxrg),         &
+              fwym(nysg:nyng,nxlg:nxrg), fwyp(nysg:nyng,nxlg:nxrg),         &
+              fxm(nysg:nyng,nxlg:nxrg), fxp(nysg:nyng,nxlg:nxrg),           &
+              fym(nysg:nyng,nxlg:nxrg), fyp(nysg:nyng,nxlg:nxrg),           &
+              nzb_s_inner(nysg:nyng,nxlg:nxrg),                             &
+              nzb_s_outer(nysg:nyng,nxlg:nxrg),                             &
+              nzb_u_inner(nysg:nyng,nxlg:nxrg),                             &
+              nzb_u_outer(nysg:nyng,nxlg:nxrg),                             &
+              nzb_v_inner(nysg:nyng,nxlg:nxrg),                             &
+              nzb_v_outer(nysg:nyng,nxlg:nxrg),                             &
+              nzb_w_inner(nysg:nyng,nxlg:nxrg),                             &
+              nzb_w_outer(nysg:nyng,nxlg:nxrg),                             &
+              nzb_diff_s_inner(nysg:nyng,nxlg:nxrg),                        &
+              nzb_diff_s_outer(nysg:nyng,nxlg:nxrg),                        &
+              nzb_diff_u(nysg:nyng,nxlg:nxrg),                              &
+              nzb_diff_v(nysg:nyng,nxlg:nxrg),                              &
+              nzb_2d(nysg:nyng,nxlg:nxrg),                                  &
+              wall_e_x(nysg:nyng,nxlg:nxrg),                                &
+              wall_e_y(nysg:nyng,nxlg:nxrg),                                &
+              wall_u(nysg:nyng,nxlg:nxrg),                                  &
+              wall_v(nysg:nyng,nxlg:nxrg),                                  &
+              wall_w_x(nysg:nyng,nxlg:nxrg),                                &
+              wall_w_y(nysg:nyng,nxlg:nxrg) )
+
+
+
+    ALLOCATE( l_wall(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
     nzb_s_inner = nzb;  nzb_s_outer = nzb
@@ -327,6 +363,6 @@
     vertical_influence(0) = vertical_influence(1)
 
-    DO  i = nxl-1, nxr+1
-       DO  j = nys-1, nyn+1
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
           DO  k = nzb_s_inner(j,i) + 1, &
                   nzb_s_inner(j,i) + vertical_influence(nzb_s_inner(j,i))
@@ -477,4 +513,6 @@
           nzb_local(:,-gls:-1)        = nzb_local(:,nx-gls+1:nx)
           nzb_local(:,nx+1:nx+gls)    = nzb_local(:,0:gls-1)
+
+
       
           GOTO 12
@@ -588,5 +626,5 @@
 !--    nzb_s_outer: 
 !--    extend nzb_local east-/westwards first, then north-/southwards
-       nzb_tmp = nzb_local(-1:ny+1,-1:nx+1)
+       nzb_tmp = nzb_local(-nbgp:ny+nbgp,-nbgp:nx+nbgp)
        DO  j = -1, ny + 1
           DO  i = 0, nx
@@ -620,5 +658,5 @@
 !--    nzb_u_inner: 
 !--    extend nzb_local rightwards only
-       nzb_tmp = nzb_local(-1:ny+1,-1:nx+1)
+       nzb_tmp = nzb_local(-nbgp:ny+nbgp,-nbgp:nx+nbgp)
        DO  j = -1, ny + 1
           DO  i = 0, nx + 1
@@ -626,5 +664,5 @@
           ENDDO
        ENDDO
-       nzb_u_inner = nzb_tmp(nys-1:nyn+1,nxl-1:nxr+1)
+       nzb_u_inner = nzb_tmp(nysg:nyng,nxlg:nxrg)
 
 !
@@ -652,5 +690,5 @@
 !--    nzb_v_inner:
 !--    extend nzb_local northwards only
-       nzb_tmp = nzb_local(-1:ny+1,-1:nx+1)
+       nzb_tmp = nzb_local(-nbgp:ny+nbgp,-nbgp:nx+nbgp)
        DO  i = -1, nx + 1
           DO  j = 0, ny + 1
@@ -658,5 +696,5 @@
           ENDDO
        ENDDO
-       nzb_v_inner = nzb_tmp(nys-1:nyn+1,nxl-1:nxr+1)
+       nzb_v_inner = nzb_tmp(nys-nbgp:nyn+nbgp,nxl-nbgp:nxr+nbgp)
 
 !
@@ -1096,5 +1134,6 @@
 !
 !-- Need to set lateral boundary conditions for l_wall
-    CALL exchange_horiz( l_wall )
+
+    CALL exchange_horiz( l_wall, nbgp )
 
     DEALLOCATE( corner_nl, corner_nr, corner_sl, corner_sr, nzb_local, &
Index: /palm/trunk/SOURCE/init_particles.f90
===================================================================
--- /palm/trunk/SOURCE/init_particles.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_particles.f90	(revision 667)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng for allocation 
+! of arrays.
 !
 ! Former revisions:
@@ -185,6 +186,6 @@
        ENDIF
 
-       ALLOCATE( prt_count(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),       &
-                 prt_start_index(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                 prt_start_index(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
                  particle_mask(maximum_number_of_particles),         &
                  particles(maximum_number_of_particles) )
@@ -209,6 +210,6 @@
 !--    particles, which can be also periodically released at later times.
 !--    Also allocate array for particle tail coordinates, if needed.
-       ALLOCATE( prt_count(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),       &
-                 prt_start_index(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+       ALLOCATE( prt_count(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                 prt_start_index(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
                  particle_mask(maximum_number_of_particles),         &
                  particles(maximum_number_of_particles) )
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 667)
@@ -4,4 +4,19 @@
 ! Current revisions:
 ! -----------------
+!
+! Moved determination of target_id's from init_coupling
+!
+! Determination of parameters needed for coupling (coupling_topology, ngp_a, ngp_o)
+! with different grid/processor-topology in ocean and atmosphere
+!
+! 
+! Adaption of ngp_xy, ngp_y to a dynamic number of ghost points.
+! The maximum_grid_level changed from 1 to 0. 0 is the normal grid, 1 to 
+! maximum_grid_level the grids for multigrid, in which 0 and 1 are normal grids.
+! This distinction is due to reasons of data exchange and performance for the 
+! normal grid and grids in poismg.
+! The definition of MPI-Vectors adapted to a dynamic numer of ghost points.
+! New MPI-Vectors for data exchange between left and right boundaries added. 
+! This is due to reasons of performance (10% faster).
 ! 
 ! ATTENTION: nnz_x undefined problem still has to be solved!!!!!!!!
@@ -79,4 +94,5 @@
 
 
+
     IMPLICIT NONE
 
@@ -88,4 +104,6 @@
 
     INTEGER, DIMENSION(:), ALLOCATABLE ::  ind_all, nxlf, nxrf, nynf, nysf
+
+    INTEGER, DIMENSION(2) :: pdims_remote
 
     LOGICAL ::  found
@@ -103,4 +121,5 @@
 
 #if defined( __parallel )
+
 !
 !-- Determine the processor topology or check it, if prescribed by the user
@@ -624,9 +643,18 @@
 #endif
 
+! 
+!-- Determine the number of ghost points
+    IF (scalar_advec == 'ws-scheme' .OR. momentum_advec == 'ws-scheme') THEN
+       nbgp = 3
+    ELSE
+       nbgp = 1
+    END IF 
+
 !
 !-- In case of coupled runs, create a new MPI derived datatype for the
 !-- exchange of surface (xy) data .
 !-- Gridpoint number for the exchange of ghost points (xy-plane)
-    ngp_xy  = ( nxr - nxl + 3 ) * ( nyn - nys + 3 )
+
+    ngp_xy  = ( nxr - nxl + 1 + 2 * nbgp ) * ( nyn - nys + 1 + 2 * nbgp )
 
 !
@@ -635,4 +663,106 @@
     CALL MPI_TYPE_VECTOR( ngp_xy, 1, nzt-nzb+2, MPI_REAL, type_xy, ierr )
     CALL MPI_TYPE_COMMIT( type_xy, ierr )
+
+
+    IF ( TRIM( coupling_mode ) .NE. 'uncoupled' ) THEN
+   
+!
+!--    Pass the number of grid points of the atmosphere model to
+!--    the ocean model and vice versa
+       IF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
+
+          nx_a = nx
+          ny_a = ny
+
+          IF ( myid == 0 ) THEN
+             CALL MPI_SEND( nx_a, 1, MPI_INTEGER, numprocs, 1, &
+                            comm_inter, ierr )
+             CALL MPI_SEND( ny_a, 1, MPI_INTEGER, numprocs, 2, &
+                            comm_inter, ierr )
+             CALL MPI_SEND( pdims, 2, MPI_INTEGER, numprocs, 3, &
+                            comm_inter, ierr )
+             CALL MPI_RECV( nx_o, 1, MPI_INTEGER, numprocs, 4, &
+                            comm_inter, status, ierr )
+             CALL MPI_RECV( ny_o, 1, MPI_INTEGER, numprocs, 5, &
+                            comm_inter, status, ierr )
+             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, numprocs, 6, &
+                            comm_inter, status, ierr )
+          ENDIF
+
+          CALL MPI_BCAST( nx_o, 1, MPI_INTEGER, 0, comm2d, ierr)
+          CALL MPI_BCAST( ny_o, 1, MPI_INTEGER, 0, comm2d, ierr) 
+          CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr)
+       
+       ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
+
+          nx_o = nx
+          ny_o = ny 
+
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( nx_a, 1, MPI_INTEGER, 0, 1, &
+                            comm_inter, status, ierr )
+             CALL MPI_RECV( ny_a, 1, MPI_INTEGER, 0, 2, &
+                            comm_inter, status, ierr )
+             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, 0, 3, &
+                            comm_inter, status, ierr )
+             CALL MPI_SEND( nx_o, 1, MPI_INTEGER, 0, 4, &
+                            comm_inter, ierr )
+             CALL MPI_SEND( ny_o, 1, MPI_INTEGER, 0, 5, &
+                            comm_inter, ierr )
+             CALL MPI_SEND( pdims, 2, MPI_INTEGER, 0, 6, &
+                            comm_inter, ierr )
+          ENDIF
+
+          CALL MPI_BCAST( nx_a, 1, MPI_INTEGER, 0, comm2d, ierr)
+          CALL MPI_BCAST( ny_a, 1, MPI_INTEGER, 0, comm2d, ierr) 
+          CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr) 
+
+       ENDIF
+  
+       ngp_a = (nx_a+1+2*nbgp)*(ny_a+1+2*nbgp)
+       ngp_o = (nx_o+1+2*nbgp)*(ny_o+1+2*nbgp)
+
+!
+!--    determine if the horizontal grid and the number of PEs 
+!--    in ocean and atmosphere is same or not
+!--    (different number of PEs still not implemented)
+       IF ( nx_o == nx_a .AND. ny_o == ny_a .AND.  &
+            pdims(1) == pdims_remote(1) .AND. pdims(2) == pdims_remote(2) ) &
+       THEN
+          coupling_topology = 0
+       ELSE
+          coupling_topology = 1
+       ENDIF 
+
+!
+!--    Determine the target PEs for the exchange between ocean and
+!--    atmosphere (comm2d)
+       IF ( coupling_topology == 0) THEN
+          IF ( TRIM( coupling_mode ) .EQ. 'atmosphere_to_ocean' ) THEN
+             target_id = myid + numprocs
+          ELSE
+             target_id = myid 
+          ENDIF
+
+       ELSE
+
+!
+!--       In case of nonequivalent topology in ocean and atmosphere only for
+!--       PE0 in ocean and PE0 in atmosphere a target_id is needed, since
+!--       data echxchange between ocean and atmosphere will be done only by
+!--       those PEs.    
+          IF ( myid == 0 ) THEN
+             IF ( TRIM( coupling_mode ) .EQ. 'atmosphere_to_ocean' ) THEN
+                target_id = numprocs 
+             ELSE
+                target_id = 0
+             ENDIF
+ print*, coupling_mode, myid, " -> ", target_id, "numprocs: ", numprocs 
+          ENDIF
+       ENDIF
+
+    ENDIF
+
+
 #endif
 
@@ -854,5 +984,5 @@
     ELSE
 
-       maximum_grid_level = 1
+       maximum_grid_level = 0
 
     ENDIF
@@ -863,13 +993,19 @@
 !
 !-- Gridpoint number for the exchange of ghost points (y-line for 2D-arrays)
-    ngp_y  = nyn - nys + 1
+    ngp_y  = nyn - nys + 1 + 2 * nbgp
 
 !
 !-- Define a new MPI derived datatype for the exchange of ghost points in
 !-- y-direction for 2D-arrays (line)
-    CALL MPI_TYPE_VECTOR( nxr-nxl+3, 1, ngp_y+2, MPI_REAL, type_x, ierr )
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_REAL, type_x, ierr )
     CALL MPI_TYPE_COMMIT( type_x, ierr )
-    CALL MPI_TYPE_VECTOR( nxr-nxl+3, 1, ngp_y+2, MPI_INTEGER, type_x_int, ierr )
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp, ngp_y, MPI_INTEGER, type_x_int, ierr )
     CALL MPI_TYPE_COMMIT( type_x_int, ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_REAL, type_y, ierr )
+    CALL MPI_TYPE_COMMIT( type_y, ierr )
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_y, ngp_y, MPI_INTEGER, type_y_int, ierr )
+    CALL MPI_TYPE_COMMIT( type_y_int, ierr )
+
 
 !
@@ -879,21 +1015,50 @@
 !-- Do these calculations for the model grid and (if necessary) also
 !-- for the coarser grid levels used in the multigrid method
-    ALLOCATE ( ngp_yz(maximum_grid_level), type_xz(maximum_grid_level) )
+    ALLOCATE ( ngp_yz(0:maximum_grid_level), type_xz(0:maximum_grid_level),&
+               type_yz(0:maximum_grid_level) )
 
     nxl_l = nxl; nxr_l = nxr; nys_l = nys; nyn_l = nyn; nzb_l = nzb; nzt_l = nzt
-         
-    DO i = maximum_grid_level, 1 , -1
-       ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
-
-       CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i), &
+!
+!-- Discern between the model grid, which needs nbgp ghost points and
+!-- grid levels for the multigrid scheme. In the latter case only one
+!-- ghost point is necessary.
+!-- First definition of mpi-vectors for exchange of ghost layers on normal 
+!-- grid. The following loop is needed for data exchange in poismg.f90.
+!
+!-- Determine number of grid points of yz-layer for exchange
+    ngp_yz(0) = (nzt - nzb + 2) * (nyn - nys + 1 + 2 * nbgp)
+!
+!-- Define a new mpi datatype for the exchange of left - right boundaries.
+!-- Indeed the data are connected in the physical memory and no mpi-vector
+!-- is necessary, but the data exchange between left and right PE's using
+!-- mpi-vectors is 10% faster than without.
+    CALL MPI_TYPE_VECTOR( nxr-nxl+1+2*nbgp, nbgp*(nzt-nzb+2), ngp_yz(0), &
+                             MPI_REAL, type_xz(0), ierr )
+    CALL MPI_TYPE_COMMIT( type_xz(0), ierr )
+
+    CALL MPI_TYPE_VECTOR( nbgp, ngp_yz(0), ngp_yz(0), MPI_REAL, type_yz(0), ierr) 
+    CALL MPI_TYPE_COMMIT( type_yz(0), ierr )
+!
+!-- Definition of mpi-vectors for multigrid
+    IF ( psolver == 'multigrid' )  THEN
+!    
+!--   The definition of mpi-vectors as aforementioned, but only 1 ghost point is used.
+       DO i = maximum_grid_level, 1 , -1
+          ngp_yz(i) = (nzt_l - nzb_l + 2) * (nyn_l - nys_l + 3)
+
+          CALL MPI_TYPE_VECTOR( nxr_l-nxl_l+3, nzt_l-nzb_l+2, ngp_yz(i), &
                              MPI_REAL, type_xz(i), ierr )
-       CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
-
-       nxl_l = nxl_l / 2 
-       nxr_l = nxr_l / 2
-       nys_l = nys_l / 2 
-       nyn_l = nyn_l / 2 
-       nzt_l = nzt_l / 2 
-    ENDDO
+          CALL MPI_TYPE_COMMIT( type_xz(i), ierr )
+
+          CALL MPI_TYPE_VECTOR( 1, ngp_yz(i), ngp_yz(i), MPI_REAL, type_yz(i), ierr)
+          CALL MPI_TYPE_COMMIT( type_yz(i), ierr )
+
+          nxl_l = nxl_l / 2
+          nxr_l = nxr_l / 2
+          nys_l = nys_l / 2
+          nyn_l = nyn_l / 2
+          nzt_l = nzt_l / 2
+       ENDDO
+    END IF
 #endif
 
Index: /palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Call of exchange_horiz are modified.
 !
 ! Former revisions:
@@ -73,5 +73,5 @@
 !
 !-- Exchange of boundary values for temperature
-    CALL exchange_horiz( pt )
+    CALL exchange_horiz( pt, nbgp )
 
 
Index: /palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- /palm/trunk/SOURCE/init_rankine.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_rankine.f90	(revision 667)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng. 
+! Calls of exchange_horiz are modified.
 !
 ! Former revisions:
@@ -55,6 +56,6 @@
 !-- Reset initial profiles to constant profiles
     IF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )  THEN
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              pt(:,j,i) = pt_init
              u(:,j,i)  = u_init
@@ -148,6 +149,6 @@
 !
 !-- Exchange of boundary values for the velocities.
-    CALL exchange_horiz( u )
-    CALL exchange_horiz( v )
+    CALL exchange_horiz( u, nbgp)
+    CALL exchange_horiz( v, nbgp )
 !
 !-- Make velocity field nondivergent.
Index: /palm/trunk/SOURCE/init_slope.f90
===================================================================
--- /palm/trunk/SOURCE/init_slope.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_slope.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -46,7 +46,7 @@
 !
 !-- Calculate reference temperature field needed for computing buoyancy
-    ALLOCATE( pt_slope_ref(nzb:nzt+1,nxl-1:nxr+1) )
+    ALLOCATE( pt_slope_ref(nzb:nzt+1,nxlg:nxrg) )
 
-    DO  i = nxl-1, nxr+1
+    DO  i = nxlg, nxrg
        DO  k = nzb, nzt+1
 
@@ -90,5 +90,5 @@
 !
 !--    Set initial temperature equal to the reference temperature field
-       DO  j = nys-1, nyn+1
+       DO  j = nysg, nyng
           pt(:,j,:) = pt_slope_ref
        ENDDO
